/* -*- buffer-read-only: t -*- vi: set ro:
#line 556
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
#line 556
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_SA
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 15 "bi_sa.m4"
/* This file is part of mailfromd.             -*- c -*-
#line 15
   Copyright (C) 2006, 2007 Sergey Poznyakoff
#line 15

#line 15
   This program is free software; you can redistribute it and/or modify
#line 15
   it under the terms of the GNU General Public License as published by
#line 15
   the Free Software Foundation; either version 3, or (at your option)
#line 15
   any later version.
#line 15

#line 15
   This program is distributed in the hope that it will be useful,
#line 15
   but WITHOUT ANY WARRANTY; without even the implied warranty of
#line 15
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#line 15
   GNU General Public License for more details.
#line 15

#line 15
   You should have received a copy of the GNU General Public License
#line 15
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <string.h>
#include <signal.h>

static size_t sa_score_loc
#line 25 "bi_sa.m4"
;
static size_t sa_threshold_loc
#line 26 "bi_sa.m4"
;
static size_t sa_keywords_loc
#line 27 "bi_sa.m4"
;
static size_t clamav_virus_name_loc
#line 28 "bi_sa.m4"
;


struct mf_stream {
	eval_environ_t env;
	mu_stream_t str;
	time_t start;
	time_t timeout;
};

typedef struct mf_stream *mf_stream_t;

/* FIXME: duplicated in engine.c */
#define UPDATE_TTW(t,start) do {                                     \
	time_t delta = time(NULL) - start;                           \
	if (t > delta)                                               \
		t -= delta;                                          \
	else                                                         \
		t = 0;                                               \
} while (0)

extern int smtp_stream_wait(mu_stream_t stream, int flags, time_t *timeout);
static void spamd_destroy(mf_stream_t *pstream);

mf_stream_t 
mf_stream_new (eval_environ_t env, mu_stream_t stream, time_t start,
	       time_t timeout) 
{
	mf_stream_t pmfs = xmalloc (sizeof pmfs[0]);
	pmfs->env = env;
	pmfs->str = stream;
	pmfs->start = start;
	pmfs->timeout = timeout;
	return pmfs;
}
	
int
mf_stream_sequential_read(mf_stream_t stream, char *buf, size_t size)
{
	int rc;
	eval_environ_t env = stream->env;
	
	if (stream->timeout == 0) {
		spamd_destroy(&stream);
			env_throw_bi(env, mf_temp_failure, NULL, "sa_sequential_read: %s",mu_strerror(ETIMEDOUT));
#line 75
	}
	
	rc = smtp_stream_wait(stream->str, MU_STREAM_READY_RD,
			      &stream->timeout);
	if (rc == 0) { 
		UPDATE_TTW(stream->timeout, stream->start);
		rc = mu_stream_sequential_read(stream->str, buf, size, NULL);
	} else {
		spamd_destroy(&stream);
			env_throw_bi(env, mf_temp_failure, NULL, "sa_sequential_read: %s",mu_strerror(ETIMEDOUT));
#line 87
	}
		
	return rc;
}

int
mf_stream_sequential_readline(mf_stream_t stream, char *buf, size_t size,
			      size_t *nbytes)
{
	int rc;
	eval_environ_t env = stream->env;
	
	if (stream->timeout == 0) {
		spamd_destroy(&stream);
			env_throw_bi(env, mf_temp_failure, NULL, "sa_sequential_readline: %s",mu_strerror(ETIMEDOUT));
#line 104
	}
	rc = smtp_stream_wait(stream->str, MU_STREAM_READY_RD,
			      &stream->timeout);
	if (rc == 0) { 
		UPDATE_TTW(stream->timeout, stream->start);
		rc = mu_stream_sequential_readline(stream->str, buf, size,
						   nbytes);
	} else {
		spamd_destroy(&stream);
			env_throw_bi(env, mf_temp_failure, NULL, "sa_sequential_readline: %s",mu_strerror(ETIMEDOUT));
#line 116
	}
	return rc;
}

int
mf_stream_sequential_write(mf_stream_t stream, char *buf, size_t size)
{
	int rc;
	eval_environ_t env = stream->env;
	
	if (stream->timeout == 0) {
		spamd_destroy(&stream);
			env_throw_bi(env, mf_temp_failure, NULL, "sa_sequential_write: %s",mu_strerror(ETIMEDOUT));
#line 131
	}

	rc = smtp_stream_wait(stream->str, MU_STREAM_READY_WR,
				  &stream->timeout);
	if (rc == 0) { 
		UPDATE_TTW(stream->timeout, stream->start);
		rc = mu_stream_sequential_write(stream->str, buf, size);
	} else {
		spamd_destroy(&stream);
			env_throw_bi(env, mf_temp_failure, NULL, "sa_sequential_write: %s",mu_strerror(ETIMEDOUT));
#line 143
	}
	return rc;
}



static int
spamd_connect_tcp(eval_environ_t env, mf_stream_t *pmfs,
		  char *host, int port, time_t timeout)
{
	mu_stream_t stream;
	int rc = mu_tcp_stream_create(&stream, host, port, 0);
		if (!(rc == 0))
#line 155
			env_throw_bi(env, mf_failure, NULL, "mu_tcp_stream_create: %s",mu_strerror(rc))
#line 157
;
	rc = mu_stream_open(stream);
		if (!(rc == 0))
#line 159
			env_throw_bi(env, mf_failure, NULL, "mu_stream_open: %s",mu_strerror(rc))
#line 161
;
	*pmfs = mf_stream_new(env, stream, time(NULL), timeout);
	return rc;
}

static int
spamd_connect_socket(eval_environ_t env, mf_stream_t *pmfs, char *path,
	             time_t timeout)
{
	int fd, rc;
	FILE *fp;
	struct sockaddr_un addr;
	mu_stream_t stream;
	
	fd = socket(PF_UNIX, SOCK_STREAM, 0);
		if (!(fd >= 0))
#line 176
			env_throw_bi(env, mf_failure, NULL, "socket: %s",mu_strerror(errno))
;

	memset(&addr, 0, sizeof addr);
	addr.sun_family = AF_UNIX;
	strncpy(addr.sun_path, path, sizeof addr.sun_path - 1);
	addr.sun_path[sizeof addr.sun_path - 1] = 0;
	if (connect(fd, (struct sockaddr *) &addr, sizeof(addr))) {
		close(fd);
			env_throw_bi(env, mf_failure, NULL, "connect: %s",mu_strerror(errno));
	}

	fp = fdopen(fd, "w+");
	rc = mu_stdio_stream_create(&stream, fp, MU_STREAM_RDWR);
	if (rc) {
		fclose(fp);
			env_throw_bi(env, mf_failure, NULL, "mu_stdio_stream_create: %s",mu_strerror(rc));
#line 195
	}

	rc = mu_stream_open(stream);
	if (rc) {
		mu_stream_destroy(&stream, mu_stream_get_owner(stream));
		fclose(fp);
			env_throw_bi(env, mf_failure, NULL, "mu_stream_open: %s",mu_strerror(rc));
#line 204
	}

	*pmfs = mf_stream_new(env, stream, time(NULL), timeout);
	
	return rc;
}

static void
spamd_shutdown(mf_stream_t stream, int isfile, int flag)
{
	int fd;
	mu_transport_t trans;
	
	mu_stream_flush(stream->str);
	mu_stream_get_transport(stream->str, &trans);
	if (isfile)
		fd = fileno((FILE*)trans);
	else
		fd = (int) trans;
	shutdown(fd, flag);
}

static void
spamd_destroy(mf_stream_t *pstream)
{
	mf_stream_t stream = *pstream;
	mu_stream_close(stream->str);
	mu_stream_destroy(&stream->str, mu_stream_get_owner(stream->str));
	free(stream);
	*pstream = NULL;
}

static void
spamd_send_command(mf_stream_t stream, const char *fmt, ...)
{
	char buf[512];
	size_t n;
	va_list ap;
	
	va_start (ap, fmt);
	n = vsnprintf (buf, sizeof buf, fmt, ap);
	va_end (ap);
	mf_stream_sequential_write(stream, buf, n);
	mf_stream_sequential_write(stream, "\r\n", 2);
}

static void
spamd_send_stream(mf_stream_t stream, mu_stream_t instr)
{
	size_t size;
	char buf[512];
	
	mu_stream_seek(instr, 0, SEEK_SET);
	while (mu_stream_sequential_readline(instr, buf, sizeof(buf),
					     &size) == 0
	       && size > 0) {
		debug3(80,"<< %*.*s", size, size, buf);
		mf_stream_sequential_write(stream, buf, size);
	}
}

static int
spamd_read_line(mf_stream_t stream, char *buffer, size_t size, size_t *pn)
{
	size_t n = 0;
	int rc = mf_stream_sequential_readline(stream, buffer, size, &n);
	if (rc == 0) {
		if (pn)
			*pn = n;
		while (n > 0 && (buffer[n-1] == '\r' || buffer[n-1] == '\n'))
			n--;
		buffer[n] = 0;
		debug1(80,">> %s", buffer);
	}
	return rc;
}

#define char_to_num(c) (c-'0')

static void
decode_float(long *vn, char *str, int digits)
{
	long v;
	size_t frac = 0;
	size_t base = 1;
	int i;
	int negative = 0;
  
	for (i = 0; i < digits; i++)
		base *= 10;
  
	v = strtol(str, &str, 10);
	if (v < 0) {
		negative = 1;
		v = - v;
	}
  
	v *= base;
	if (*str == '.') {
		for (str++, i = 0; *str && i < digits; i++, str++)
			frac = frac * 10 + char_to_num (*str);
		if (*str) {
			if (char_to_num(*str) >= 5)
				frac++;
		}
		else
			for (; i < digits; i++)
				frac *= 10;
	}
	*vn = v + frac;
	if (negative)
		*vn = - *vn;
}

static int
decode_boolean(char *str)
{
	if (strcasecmp(str, "true") == 0)
		return 1;
	else if (strcasecmp(str, "false") == 0)
		return 0;
	/*else?*/
	return 0;
}

typedef RETSIGTYPE (*signal_handler_fn)(int);

static signal_handler_fn
set_signal_handler (int sig, signal_handler_fn h)
{
#ifdef HAVE_SIGACTION
	struct sigaction act, oldact;
	act.sa_handler = h;
	sigemptyset (&act.sa_mask);
	act.sa_flags = 0;
	sigaction (sig, &act, &oldact);
	return oldact.sa_handler;
#else
	return signal (sig, h);
#endif
}

static int got_sigpipe;

static RETSIGTYPE
sigpipe_handler (int sig)
{
	got_sigpipe = 1;
}

mf_stream_t
open_connection(eval_environ_t env, char *urlstr, int *isfile, char **phost,
		long timeout)
{
	char *path = NULL;
	short port = 0;
	mf_stream_t str = NULL;
	int rc;
	
	if (urlstr[0] == '/') {
		path = strdup(urlstr);
		if (!path)
			runtime_error(env, _("Not enough memory"));
	} else {
		char buffer[10];
		mu_url_t url = NULL;
		
		rc = mu_url_create(&url, urlstr);
		if (rc)
				env_throw_bi(env, mf_failure, NULL, _("Cannot create URL from `%s': %s"),urlstr,mu_strerror(rc));
#line 376
		
		if (rc = mu_url_parse(url)) {
			mu_url_destroy(&url);
				env_throw_bi(env, mf_url, NULL, _("%s: error parsing URL: %s"),urlstr,mu_strerror(rc));
#line 382
		}

		if (rc = mu_url_get_scheme(url, buffer, sizeof buffer, NULL)) {
			mu_url_destroy(&url);
				env_throw_bi(env, mf_url, NULL, _("%s: cannot get scheme: %s"),urlstr,mu_strerror(rc));
#line 389
		}

		if (strcmp(buffer, "file") == 0
		    || strcmp(buffer, "socket") == 0) {
			size_t size;
			if (rc = mu_url_get_path(url, NULL, 0, &size)) {
					env_throw_bi(env, mf_url, NULL, _("%s: cannot get path: %s"),urlstr,mu_strerror(rc));
#line 398
			}
			path = malloc(size + 1);
			if (!path) {
				mu_url_destroy(&url);
				runtime_error(env, _("Not enough memory"));
			}
			mu_url_get_path(url, path, size + 1, NULL);
		} else if (strcmp(buffer, "tcp") == 0) {
			size_t size;
			long n;

			if (mu_url_get_port(url, &n)) {
				mu_url_destroy(&url);
					env_throw_bi(env, mf_url, NULL, _("%s: cannot get port: %s"),urlstr,mu_strerror(rc));
#line 414
			}

			if (n == 0 || (port = n) != n) {
				mu_url_destroy(&url);
					env_throw_bi(env, mf_range, NULL, _("Port out of range: %s"),mu_strerror(rc));
#line 421
			}
			
			if (rc = mu_url_get_host(url, NULL, 0, &size)) {
				mu_url_destroy(&url);
					env_throw_bi(env, mf_url, NULL, _("%s: cannot get host: %s"),urlstr,mu_strerror(rc));
#line 428
			}
			path = malloc(size + 1);
			if (!path) {
				mu_url_destroy(&url);
				runtime_error(env, _("Not enough memory"));
			}
			mu_url_get_host(url, path, size + 1, NULL);
		} else
				env_throw_bi(env, mf_url, NULL, _("Invalid URL: %s"),buffer);
#line 438

		mu_url_destroy(&url);
	}

	if (port == 0) {
		rc = spamd_connect_socket(env, &str, path, timeout);
		*isfile = 1;
	} else {
		rc = spamd_connect_tcp(env, &str, path, port, timeout);
		*isfile = 0;
	}
	
	if (rc == 0 && phost) {
		if (port) {
			*phost = path;
			path = NULL;
		} else
			*phost = NULL;
	}

	free(path);

	return str;
}	


	
void
#line 465
bi_sa(eval_environ_t env)
#line 465

#line 465 "bi_sa.m4"
{
#line 465
	
#line 465

#line 465
long __bi_argcnt = (long)get_numeric_arg(env, 0);
#line 465
char * urlstr = (char *) get_string_arg(env, 1);
#line 465
        long  prec = (long ) get_numeric_arg(env, 2);
#line 465
        long  timeout = (long ) get_numeric_arg(env, 3);
#line 465
        
#line 465
        adjust_stack(env, __bi_argcnt + 1);
#line 465

#line 465
	if (prog_trace_option & BUILTIN_MASK_sa)
#line 465
		prog_trace(env, "sa %s %lu %lu",urlstr, prec, ((__bi_argcnt > 2) ? timeout : 0));;
#line 465

{
	mu_off_t msize;
	size_t size;
	mu_stream_t mstr = env_get_stream(env);
	mf_stream_t ostr;
	signal_handler_fn handler;
	char buffer[512];
	char version_str[19];
	char spam_str[6], score_str[21], threshold_str[21];
	long version;
	int result;
	long score, threshold;
	int isfile;
	
	ostr = open_connection(env, urlstr, &isfile, NULL,
			       ((__bi_argcnt > 2) ? timeout : 7200));
	mu_stream_size(mstr, &msize);
	spamd_send_command(ostr, "SYMBOLS SPAMC/1.2");
	spamd_send_command(ostr, "Content-length: %lu",
			   (unsigned long) msize);
	/*FIXME: spamd_send_command(ostr, "User: %s", ??) */
	got_sigpipe = 0;
	handler = set_signal_handler(SIGPIPE, sigpipe_handler);
	spamd_send_command(ostr, "");
	spamd_send_stream(ostr, mstr);
	spamd_shutdown(ostr, isfile, SHUT_WR);
	set_signal_handler(SIGPIPE, handler);
	
	spamd_read_line(ostr, buffer, sizeof buffer, NULL);
	if (got_sigpipe) {
		spamd_destroy(&ostr);
			env_throw_bi(env, mf_failure, "sa", _("Remote side has closed connection"));
	}

	if (sscanf(buffer, "SPAMD/%18s %d %*s", version_str, &result) != 2) {
		spamd_destroy(&ostr);
			env_throw_bi(env, mf_failure, "sa", _("spamd responded with bad string '%s'"),buffer);
#line 505
	}

	decode_float(&version, version_str, 1);
	if (version < 10) {
		spamd_destroy(&ostr);
			env_throw_bi(env, mf_failure, "sa", _("Unsupported SPAMD version: %s"),version_str);
#line 513
	}

	spamd_read_line(ostr, buffer, sizeof buffer, NULL);
	if (sscanf (buffer, "Spam: %5s ; %20s / %20s",
		    spam_str, score_str, threshold_str) != 3) {
		spamd_destroy(&ostr);
			env_throw_bi(env, mf_failure, "sa", _("spamd responded with bad Spam header '%s'"),buffer);
#line 522
	}

	result = decode_boolean(spam_str);
	decode_float(&score, score_str, prec);
	decode_float(&threshold, threshold_str, prec);

	/* Skip newline */
	spamd_read_line(ostr, buffer, sizeof buffer, NULL);
	/* Read symbol list */
	spamd_read_line(ostr, buffer, sizeof buffer, &size);

	*env_data_ref(env, sa_score_loc) = (STKVAL) (score);
	*env_data_ref(env, sa_threshold_loc) = (STKVAL) (threshold);
	
#line 535
{ size_t off;
#line 535
  if (buffer)
#line 535
     strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(buffer) + 1)), buffer);
#line 535
  else
#line 535
     off = 0;
#line 535
  *env_data_ref(env, sa_keywords_loc) = (STKVAL) (off); }
#line 535
;
	
	while (spamd_read_line(ostr, buffer, sizeof buffer, &size) == 0
	       && size > 0)
		/* Drain input */;
  	spamd_destroy(&ostr);
	
	
#line 542
do {
#line 542
  push(env, (STKVAL) (result));
#line 542
  return;
#line 542
} while (0);
}
}


	
void
#line 548
bi_clamav(eval_environ_t env)
#line 548

#line 548 "bi_sa.m4"
{
#line 548
	
#line 548

#line 548
long __bi_argcnt = (long)get_numeric_arg(env, 0);
#line 548
char * urlstr = (char *) get_string_arg(env, 1);
#line 548
        long  timeout = (long ) get_numeric_arg(env, 2);
#line 548
        
#line 548
        adjust_stack(env, __bi_argcnt + 1);
#line 548

#line 548
	if (prog_trace_option & BUILTIN_MASK_sa)
#line 548
		prog_trace(env, "clamav %s %lu",urlstr, ((__bi_argcnt > 1) ? timeout : 0));;
#line 548

{
	mu_stream_t mstr = env_get_stream(env);
	mf_stream_t cstr, dstr;
	mu_stream_t str;
	char buffer[512];
	char *host;
	unsigned short port;
	int rc;
	signal_handler_fn handler;
	char *p;
	int isfile;

	cstr = open_connection(env, urlstr, &isfile, &host,
			       ((__bi_argcnt > 1) ? timeout : 7200));

	spamd_send_command(cstr, "STREAM");
	spamd_read_line(cstr, buffer, sizeof buffer, NULL);
	if (sscanf(buffer, "PORT %hu\n", &port) != 1) {
		spamd_destroy(&cstr);
			env_throw_bi(env, mf_failure, "clamav", _("Bad response from clamav: expected `PORT' but found `%s'"),buffer);
#line 571
	}

	if (!host) 
		host = strdup("127.0.0.1"); /* FIXME */

	rc = mu_tcp_stream_create(&str, host, port, 0);
	free(host);
	if (rc) {
		spamd_destroy(&cstr);
			env_throw_bi(env, mf_failure, "clamav", "mu_tcp_stream_create: %s",mu_strerror(rc));
#line 583
	}

	rc = mu_stream_open(str);
	if (rc) {
		spamd_destroy(&cstr);
		mu_stream_destroy(&str, mu_stream_get_owner(str));
			env_throw_bi(env, mf_failure, "clamav", "mu_stream_open: %s",mu_strerror(rc));
#line 592
	}

	handler = set_signal_handler(SIGPIPE, sigpipe_handler);
	dstr = mf_stream_new (env, str, cstr->start, cstr->timeout);
	spamd_send_stream(dstr, mstr);
	spamd_shutdown(dstr, 0, SHUT_WR);
	spamd_destroy(&dstr);
	
	set_signal_handler(SIGPIPE, handler);

	rc = spamd_read_line(cstr, buffer, sizeof buffer, NULL);
	spamd_destroy(&cstr);
		if (!(rc == 0))
#line 604
			env_throw_bi(env, mf_failure, "clamav", _("Error reading clamav response: %s"),mu_strerror(rc))
;

	p = strrchr(buffer, ' ');
        	if (!(p))
#line 608
			env_throw_bi(env, mf_failure, "clamav", _("Unknown clamav response: %s"),buffer)
;
	++p;
	if (strncmp(p, "OK", 2) == 0)
		rc = 0;
	else if (strncmp(p, "FOUND", 5) == 0) {
		char *s;
			
		*--p = '\0';
		s = strrchr(buffer, ' ');
		if (!s)
			s = buffer;
		else
			s++;
		
#line 622
{ size_t off;
#line 622
  if (s)
#line 622
     strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(s) + 1)), s);
#line 622
  else
#line 622
     off = 0;
#line 622
  *env_data_ref(env, clamav_virus_name_loc) = (STKVAL) (off); }
#line 622
;

		debug2(2,
		       "%sclamav found %s",
		       mailfromd_msgid(env_get_context(env)),
		       s);
		rc = 1;
	} else if (strncmp(p, "ERROR", 5) == 0) {
		/* FIXME: mf code */
			env_throw_bi(env, mf_failure, "clamav", _("Clamav error: %s"),buffer);
#line 634
	} else {
			env_throw_bi(env, mf_failure, "clamav", _("Unknown clamav response: %s"),buffer);
#line 638
	}

	
#line 640
do {
#line 640
  push(env, (STKVAL) (rc));
#line 640
  return;
#line 640
} while (0);
}
}


#line 644
void
#line 644
sa_init_builtin()
#line 644
{
#line 644
	#line 25 "bi_sa.m4"
	sa_score_loc = builtin_variable_install("sa_score", dtype_number, VAR_VOLATILE)->off;
#line 26 "bi_sa.m4"
	sa_threshold_loc = builtin_variable_install("sa_threshold", dtype_number, VAR_VOLATILE)->off;
#line 27 "bi_sa.m4"
	sa_keywords_loc = builtin_variable_install("sa_keywords", dtype_string, VAR_VOLATILE)->off;
#line 28 "bi_sa.m4"
	clamav_virus_name_loc = builtin_variable_install("clamav_virus_name", dtype_string, VAR_VOLATILE)->off;
#line 465 "bi_sa.m4"
va_builtin_install_ex("sa", bi_sa, EXMASK(smtp_state_eom), 1, dtype_number, 3, 1, 0, dtype_string, dtype_number, dtype_number);
#line 548 "bi_sa.m4"
va_builtin_install_ex("clamav", bi_clamav, EXMASK(smtp_state_eom), 1, dtype_number, 2, 1, 0, dtype_string, dtype_number);

#line 644 "bi_sa.m4"
		
#line 644
}

#line 547 "../src/snarf.m4"

#line 547

